diff --git a/gcc/analyzer/engine.cc b/gcc/analyzer/engine.cc
index 9d22950d79b..14737295831 100644
--- a/gcc/analyzer/engine.cc
+++ b/gcc/analyzer/engine.cc
@@ -1460,422 +1300,69 @@ fndecl_has_gimple_body_p (tree fndecl)
 
 namespace ana {
 
-/* Modify STATE in place, applying the effects of the stmt at this node's
-   point.  */
-
-exploded_node::on_stmt_flags
-exploded_node::on_stmt (exploded_graph &eg,
-			const supernode *snode,
-			const gimple *stmt,
-			program_state *state,
-			uncertainty_t *uncertainty,
-			bool *out_could_have_done_work,
-			path_context *path_ctxt)
-{
-  logger *logger = eg.get_logger ();
-  LOG_SCOPE (logger);
-  if (logger)
-    {
-      logger->start_log_line ();
-      pp_gimple_stmt_1 (logger->get_printer (), stmt, 0, (dump_flags_t)0);
-      logger->end_log_line ();
-    }
-
-  /* Update input_location in case of ICE: make it easier to track down which
-     source construct we're failing to handle.  */
-  input_location = stmt->location;
+/* Verify that the stack at LONGJMP_POINT is still valid, given a call
+   to "setjmp" at SETJMP_POINT - the stack frame that "setjmp" was
+   called in must still be valid.
 
-  gcc_assert (state->m_region_model);
+   Caveat: this merely checks the call_strings in the points; it doesn't
+   detect the case where a frame returns and is then called again.  */
 
-  /* Preserve the old state.  It is used here for looking
-     up old checker states, for determining state transitions, and
-     also within impl_region_model_context and impl_sm_context for
-     going from tree to svalue_id.  */
-  const program_state old_state (*state);
+static bool
+valid_longjmp_stack_p (const program_point &longjmp_point,
+		       const program_point &setjmp_point)
+{
+  const call_string &cs_at_longjmp = longjmp_point.get_call_string ();
+  const call_string &cs_at_setjmp = setjmp_point.get_call_string ();
 
-  impl_region_model_context ctxt (eg, this,
-				  &old_state, state, uncertainty,
-				  path_ctxt, stmt, nullptr,
-				  out_could_have_done_work);
-
-  /* Handle call summaries here.  */
-  if (cgraph_edge *cgedge
-	  = supergraph_call_edge (snode->get_function (), stmt))
-    if (eg.get_analysis_plan ().use_summary_p (cgedge))
-      {
-	function *called_fn = get_ultimate_function_for_cgraph_edge (cgedge);
-	per_function_data *called_fn_data
-	  = eg.get_per_function_data (called_fn);
-	if (called_fn_data)
-	  {
-	    gcc_assert (called_fn);
-	    return replay_call_summaries (eg,
-					  snode,
-					  *as_a <const gcall *> (stmt),
-					  state,
-					  path_ctxt,
-					  *called_fn,
-					  *called_fn_data,
-					  &ctxt);
-	  }
-      }
+  if (cs_at_longjmp.length () < cs_at_setjmp.length ())
+    return false;
 
-  bool unknown_side_effects = false;
-  bool terminate_path = false;
+  /* Check that the call strings match, up to the depth of the
+     setjmp point.  */
+  for (unsigned depth = 0; depth < cs_at_setjmp.length (); depth++)
+    if (cs_at_longjmp[depth] != cs_at_setjmp[depth])
+      return false;
 
-  on_stmt_pre (eg, stmt, state, &terminate_path,
-	       &unknown_side_effects, &ctxt);
+  return true;
+}
 
-  if (terminate_path)
-    return on_stmt_flags::terminate_path ();
+/* A pending_diagnostic subclass for complaining about bad longjmps,
+   where the enclosing function of the "setjmp" has returned (and thus
+   the stack frame no longer exists).  */
 
-  int sm_idx;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (old_state.m_checker_states, sm_idx, smap)
-    {
-      const state_machine &sm = eg.get_ext_state ().get_sm (sm_idx);
-      const sm_state_map *old_smap
-	= old_state.m_checker_states[sm_idx];
-      sm_state_map *new_smap = state->m_checker_states[sm_idx];
-      impl_sm_context sm_ctxt (eg, sm_idx, sm, this, &old_state, state,
-			       old_smap, new_smap, path_ctxt, nullptr,
-			       unknown_side_effects);
-
-      /* Allow the state_machine to handle the stmt.  */
-      if (sm.on_stmt (sm_ctxt, snode, stmt))
-	unknown_side_effects = false;
-    }
+class stale_jmp_buf : public pending_diagnostic_subclass<stale_jmp_buf>
+{
+public:
+  stale_jmp_buf (const gcall &setjmp_call, const gcall &longjmp_call,
+		 const program_point &setjmp_point)
+  : m_setjmp_call (setjmp_call), m_longjmp_call (longjmp_call),
+    m_setjmp_point (setjmp_point), m_stack_pop_event (nullptr)
+  {}
 
-  if (path_ctxt->terminate_path_p ())
-    return on_stmt_flags::terminate_path ();
+  int get_controlling_option () const final override
+  {
+    return OPT_Wanalyzer_stale_setjmp_buffer;
+  }
 
-  on_stmt_post (stmt, state, unknown_side_effects, &ctxt);
+  bool emit (diagnostic_emission_context &ctxt) final override
+  {
+    return ctxt.warn ("%qs called after enclosing function of %qs has returned",
+		      get_user_facing_name (m_longjmp_call),
+		      get_user_facing_name (m_setjmp_call));
+  }
 
-  return on_stmt_flags ();
-}
+  const char *get_kind () const final override
+  { return "stale_jmp_buf"; }
 
-/* Handle the pre-sm-state part of STMT, modifying STATE in-place.
-   Write true to *OUT_TERMINATE_PATH if the path should be terminated.
-   Write true to *OUT_UNKNOWN_SIDE_EFFECTS if the stmt has unknown
-   side effects.  */
-
-void
-exploded_node::on_stmt_pre (exploded_graph &eg,
-			    const gimple *stmt,
-			    program_state *state,
-			    bool *out_terminate_path,
-			    bool *out_unknown_side_effects,
-			    region_model_context *ctxt)
-{
-  /* Handle special-case calls that require the full program_state.  */
-  if (const gcall *call_stmt = dyn_cast <const gcall *> (stmt))
-    {
-      const gcall &call = *call_stmt;
-      if (is_special_named_call_p (call, "__analyzer_dump", 0))
-	{
-	  /* Handle the builtin "__analyzer_dump" by dumping state
-	     to stderr.  */
-	  state->dump (eg.get_ext_state (), true);
-	  return;
-	}
-      else if (is_special_named_call_p (call, "__analyzer_dump_sarif", 0))
-	{
-	  state->dump_sarif (eg.get_ext_state ());
-	  return;
-	}
-      else if (is_special_named_call_p (call, "__analyzer_dump_dot", 0))
-	{
-	  state->dump_dot (eg.get_ext_state ());
-	  return;
-	}
-      else if (is_special_named_call_p (call, "__analyzer_dump_state", 2))
-	{
-	  state->impl_call_analyzer_dump_state (call, eg.get_ext_state (),
-						ctxt);
-	  return;
-	}
-      else if (is_setjmp_call_p (call))
-	{
-	  state->m_region_model->on_setjmp (call, this, ctxt);
-	  if (ctxt)
-	    ctxt->maybe_did_work ();
-	  return;
-	}
-      else if (is_longjmp_call_p (call))
-	{
-	  on_longjmp (eg, call, state, ctxt);
-	  *out_terminate_path = true;
-	  if (ctxt)
-	    ctxt->maybe_did_work ();
-	  return;
-	}
-      else if (is_cxa_throw_p (call))
-	{
-	  on_throw (eg, call, state, false, ctxt);
-	  *out_terminate_path = true;
-	  return;
-	}
-      else if (is_cxa_rethrow_p (call))
-	{
-	  on_throw (eg, call, state, true, ctxt);
-	  *out_terminate_path = true;
-	  return;
-	}
-    }
-  else if (const gresx *resx = dyn_cast <const gresx *> (stmt))
-    {
-      on_resx (eg, *resx, state, ctxt);
-      *out_terminate_path = true;
-      return;
-    }
-
-  /* Otherwise, defer to m_region_model.  */
-  state->m_region_model->on_stmt_pre (stmt,
-				      out_unknown_side_effects,
-				      ctxt);
-}
-
-/* Handle the post-sm-state part of STMT, modifying STATE in-place.  */
-
-void
-exploded_node::on_stmt_post (const gimple *stmt,
-			     program_state *state,
-			     bool unknown_side_effects,
-			     region_model_context *ctxt)
-{
-  if (const gcall *call = dyn_cast <const gcall *> (stmt))
-    state->m_region_model->on_call_post (*call, unknown_side_effects, ctxt);
-}
-
-/* A concrete call_info subclass representing a replay of a call summary.  */
-
-class call_summary_edge_info : public call_info
-{
-public:
-  call_summary_edge_info (const call_details &cd,
-			  const function &called_fn,
-			  call_summary &summary,
-			  const extrinsic_state &ext_state)
-  : call_info (cd, called_fn),
-    m_called_fn (called_fn),
-    m_summary (summary),
-    m_ext_state (ext_state)
-  {}
-
-  bool update_state (program_state *state,
-		     const exploded_edge *,
-		     region_model_context *ctxt) const final override
-  {
-    /* Update STATE based on summary_end_state.  */
-    call_details cd (get_call_details (state->m_region_model, ctxt));
-    call_summary_replay r (cd, m_called_fn, m_summary, m_ext_state);
-    const program_state &summary_end_state = m_summary.get_state ();
-    return state->replay_call_summary (r, summary_end_state);
-  }
-
-  bool update_model (region_model *model,
-		     const exploded_edge *,
-		     region_model_context *ctxt) const final override
-  {
-    /* Update STATE based on summary_end_state.  */
-    call_details cd (get_call_details (model, ctxt));
-    call_summary_replay r (cd, m_called_fn, m_summary, m_ext_state);
-    const program_state &summary_end_state = m_summary.get_state ();
-    model->replay_call_summary (r, *summary_end_state.m_region_model);
-    return true;
-  }
-
-  void print_desc (pretty_printer &pp) const final override
-  {
-    pp_string (&pp, m_summary.get_desc ().get ());
-  }
-
-private:
-  const function &m_called_fn;
-  call_summary &m_summary;
-  const extrinsic_state &m_ext_state;
-};
-
-/* Use PATH_CTXT to bifurcate, which when handled will add custom edges
-   for a replay of the various feasible summaries in CALLED_FN_DATA.  */
-
-exploded_node::on_stmt_flags
-exploded_node::replay_call_summaries (exploded_graph &eg,
-				      const supernode *snode,
-				      const gcall &call_stmt,
-				      program_state *state,
-				      path_context *path_ctxt,
-				      const function &called_fn,
-				      per_function_data &called_fn_data,
-				      region_model_context *ctxt)
-{
-  logger *logger = eg.get_logger ();
-  LOG_SCOPE (logger);
-
-  /* Each summary will call bifurcate on the PATH_CTXT.  */
-  for (auto summary : called_fn_data.m_summaries)
-    {
-      gcc_assert (summary);
-      replay_call_summary (eg, snode, call_stmt, state,
-			   path_ctxt, called_fn, *summary, ctxt);
-    }
-  path_ctxt->terminate_path ();
-
-  return on_stmt_flags ();
-}
-
-/* Use PATH_CTXT to bifurcate, which when handled will add a
-   custom edge for a replay of SUMMARY, if the summary's
-   conditions are feasible based on the current state.  */
-
-void
-exploded_node::replay_call_summary (exploded_graph &eg,
-				    const supernode *snode,
-				    const gcall &call_stmt,
-				    program_state *old_state,
-				    path_context *path_ctxt,
-				    const function &called_fn,
-				    call_summary &summary,
-				    region_model_context *ctxt)
-{
-  logger *logger = eg.get_logger ();
-  LOG_SCOPE (logger);
-  gcc_assert (snode);
-  gcc_assert (old_state);
-
-  if (logger)
-    logger->log ("using %s as summary for call to %qE from %qE",
-		 summary.get_desc ().get (),
-		 called_fn.decl,
-		 snode->get_function ()->decl);
-  const extrinsic_state &ext_state = eg.get_ext_state ();
-  const program_state &summary_end_state = summary.get_state ();
-  if (logger)
-    {
-      pretty_printer *pp = logger->get_printer ();
-
-      logger->start_log_line ();
-      pp_string (pp, "callsite state: ");
-      old_state->dump_to_pp (ext_state, true, false, pp);
-      logger->end_log_line ();
-
-      logger->start_log_line ();
-      pp_string (pp, "summary end state: ");
-      summary_end_state.dump_to_pp (ext_state, true, false, pp);
-      logger->end_log_line ();
-    }
-
-  program_state new_state (*old_state);
-
-  call_details cd (call_stmt, new_state.m_region_model, ctxt);
-  call_summary_replay r (cd, called_fn, summary, ext_state);
-
-  if (path_ctxt)
-    path_ctxt->bifurcate
-      (std::make_unique<call_summary_edge_info> (cd,
-						 called_fn,
-						 summary,
-						 ext_state));
-}
-
-
-/* Consider the effect of following superedge SUCC from this node.
-
-   Return true if it's feasible to follow the edge, or false
-   if it's infeasible.
-
-   Examples: if it's the "true" branch within
-   a CFG and we know the conditional is false, we know it's infeasible.
-   If it's one of multiple interprocedual "return" edges, then only
-   the edge back to the most recent callsite is feasible.
-
-   Update NEXT_STATE accordingly (e.g. to record that a condition was
-   true or false, or that the NULL-ness of a pointer has been checked,
-   pushing/popping stack frames, etc).
-
-   Update NEXT_POINT accordingly (updating the call string).  */
-
-bool
-exploded_node::on_edge (exploded_graph &eg,
-			const superedge *succ,
-			program_point *next_point,
-			program_state *next_state,
-			uncertainty_t *uncertainty)
-{
-  LOG_FUNC (eg.get_logger ());
-
-  if (!next_point->on_edge (eg, succ))
-    return false;
-
-  if (!next_state->on_edge (eg, this, succ, uncertainty))
-    return false;
-
-  return true;
-}
-
-/* Verify that the stack at LONGJMP_POINT is still valid, given a call
-   to "setjmp" at SETJMP_POINT - the stack frame that "setjmp" was
-   called in must still be valid.
-
-   Caveat: this merely checks the call_strings in the points; it doesn't
-   detect the case where a frame returns and is then called again.  */
-
-static bool
-valid_longjmp_stack_p (const program_point &longjmp_point,
-		       const program_point &setjmp_point)
-{
-  const call_string &cs_at_longjmp = longjmp_point.get_call_string ();
-  const call_string &cs_at_setjmp = setjmp_point.get_call_string ();
-
-  if (cs_at_longjmp.length () < cs_at_setjmp.length ())
-    return false;
-
-  /* Check that the call strings match, up to the depth of the
-     setjmp point.  */
-  for (unsigned depth = 0; depth < cs_at_setjmp.length (); depth++)
-    if (cs_at_longjmp[depth] != cs_at_setjmp[depth])
-      return false;
-
-  return true;
-}
-
-/* A pending_diagnostic subclass for complaining about bad longjmps,
-   where the enclosing function of the "setjmp" has returned (and thus
-   the stack frame no longer exists).  */
-
-class stale_jmp_buf : public pending_diagnostic_subclass<stale_jmp_buf>
-{
-public:
-  stale_jmp_buf (const gcall &setjmp_call, const gcall &longjmp_call,
-		 const program_point &setjmp_point)
-  : m_setjmp_call (setjmp_call), m_longjmp_call (longjmp_call),
-    m_setjmp_point (setjmp_point), m_stack_pop_event (nullptr)
-  {}
-
-  int get_controlling_option () const final override
-  {
-    return OPT_Wanalyzer_stale_setjmp_buffer;
-  }
-
-  bool emit (diagnostic_emission_context &ctxt) final override
-  {
-    return ctxt.warn ("%qs called after enclosing function of %qs has returned",
-		      get_user_facing_name (m_longjmp_call),
-		      get_user_facing_name (m_setjmp_call));
-  }
-
-  const char *get_kind () const final override
-  { return "stale_jmp_buf"; }
-
-  bool operator== (const stale_jmp_buf &other) const
-  {
-    return (&m_setjmp_call == &other.m_setjmp_call
-	    && &m_longjmp_call == &other.m_longjmp_call);
-  }
+  bool operator== (const stale_jmp_buf &other) const
+  {
+    return (&m_setjmp_call == &other.m_setjmp_call
+	    && &m_longjmp_call == &other.m_longjmp_call);
+  }
 
   bool
-  maybe_add_custom_events_for_superedge (const exploded_edge &eedge,
-					 checker_path *emission_path)
+  maybe_add_custom_events_for_eedge (const exploded_edge &eedge,
+				     checker_path *emission_path)
     final override
   {
     /* Detect exactly when the stack first becomes invalid,
@@ -1963,21 +1450,22 @@ exploded_node::on_longjmp (exploded_graph &eg,
   rewind_info_t rewind_info (tmp_setjmp_record, longjmp_call);
 
   const gcall &setjmp_call = rewind_info.get_setjmp_call ();
-  const program_point &setjmp_point = rewind_info.get_setjmp_point ();
+  const program_point point_before_setjmp = rewind_info.get_point_before_setjmp ();
+  const program_point point_after_setjmp = rewind_info.get_point_after_setjmp ();
 
   const program_point &longjmp_point = get_point ();
 
   /* Verify that the setjmp's call_stack hasn't been popped.  */
-  if (!valid_longjmp_stack_p (longjmp_point, setjmp_point))
+  if (!valid_longjmp_stack_p (longjmp_point, point_after_setjmp))
     {
       ctxt->warn (std::make_unique<stale_jmp_buf> (setjmp_call,
 						   longjmp_call,
-						   setjmp_point));
+						   point_before_setjmp));
       return;
     }
 
   gcc_assert (longjmp_point.get_stack_depth ()
-	      >= setjmp_point.get_stack_depth ());
+	      >= point_after_setjmp.get_stack_depth ());
 
   /* Update the state for use by the destination node.  */
 
@@ -1988,18 +1476,13 @@ exploded_node::on_longjmp (exploded_graph &eg,
   unsigned prev_num_diagnostics = dm->get_num_diagnostics ();
 
   new_region_model->on_longjmp (longjmp_call, setjmp_call,
-				setjmp_point.get_stack_depth (), ctxt);
+				point_after_setjmp.get_stack_depth (), ctxt);
 
   /* Detect leaks in the new state relative to the old state.  */
   program_state::detect_leaks (get_state (), *new_state, nullptr,
 				eg.get_ext_state (), ctxt);
-
-  program_point next_point
-    = program_point::after_supernode (setjmp_point.get_supernode (),
-				      setjmp_point.get_call_string ());
-
   exploded_node *next
-    = eg.get_or_create_node (next_point, *new_state, this);
+    = eg.get_or_create_node (point_after_setjmp, *new_state, this);
 
   /* Create custom exploded_edge for a longjmp.  */
   if (next)
@@ -2111,7 +1594,8 @@ public:
   }
 
   void add_events_to_path (checker_path *emission_path,
-			   const exploded_edge &eedge) const final override
+			   const exploded_edge &eedge,
+			   pending_diagnostic &) const final override
   {
     const exploded_node *dst_node = eedge.m_dest;
     const program_point &dst_point = dst_node->get_point ();
@@ -2160,7 +1644,8 @@ public:
   }
 
   void add_events_to_path (checker_path *emission_path,
-			   const exploded_edge &eedge) const final override
+			   const exploded_edge &eedge,
+			   pending_diagnostic &) const final override
   {
     const exploded_node *src_node = eedge.m_src;
     const program_point &src_point = src_node->get_point ();
@@ -2224,9 +1709,8 @@ exploded_graph::unwind_from_exception (exploded_node &thrown_enode,
 	     Assume we have an out-edge flagged with EH leading to
 	     code for dispatch to catch handlers.  */
 	  const program_point next_point
-	    = program_point::before_supernode (sedge->m_dest,
-					       sedge,
-					       iter_enode->get_point ().get_call_string ());
+	    (sedge->m_dest,
+	     iter_enode->get_point ().get_call_string ());
 	  exploded_node *next_enode
 	    = get_or_create_node (next_point,
 				  iter_enode->get_state (),
@@ -2278,8 +1762,7 @@ exploded_graph::unwind_from_exception (exploded_node &thrown_enode,
 	    {
 	      /* Nested function in analysis: unwinding to
 		 the callsite in the analysis (or beyond).  */
-	      program_point unwound_point
-		= program_point::after_supernode (cs.get_caller_node (), cs);
+	      program_point unwound_point (cs.get_return_node_in_caller (), cs);
 	      unwound_point.pop_from_call_stack ();
 
 	      exploded_node *after_unwind_enode
@@ -2313,6 +1796,7 @@ exploded_graph::unwind_from_exception (exploded_node &thrown_enode,
 void
 exploded_node::on_throw (exploded_graph &eg,
 			 const gcall &throw_call,
+			 const program_point &after_throw_point,
 			 program_state *new_state,
 			 bool is_rethrow,
 			 region_model_context *ctxt)
@@ -2333,12 +1817,11 @@ exploded_node::on_throw (exploded_graph &eg,
       const svalue *tinfo_sval = cd.get_arg_svalue (1);
       type = tinfo_sval->maybe_get_type_from_typeinfo ();
     }
+
   auto throw_edge_info
     = std::make_unique<throw_custom_edge> (cd, type, is_rethrow);
   throw_edge_info->update_model (model, nullptr, ctxt);
 
-  program_point after_throw_point = get_point ().get_next ();
-
   exploded_node *after_throw_enode
     = eg.get_or_create_node (after_throw_point, *new_state, this,
 			     /* Don't add to worklist; we process
@@ -2355,22 +1838,6 @@ exploded_node::on_throw (exploded_graph &eg,
   eg.unwind_from_exception (*after_throw_enode, &throw_call, ctxt);
 }
 
-/* Handle a gimple "resx" statement by adding eedges and enode.
-   that unwind to the next eh_dispatch statement, if any.  Only
-   the final enode is added to the worklist.  */
-
-void
-exploded_node::on_resx (exploded_graph &eg,
-			const gresx &/*resx*/,
-			program_state */*new_state*/,
-			region_model_context *ctxt)
-{
-  eg.unwind_from_exception (*this,
-			    nullptr,
-			    ctxt);
-}
-
-
 /* Subroutine of exploded_graph::process_node for finding the successors
    of the supernode for a function exit basic block.
 
@@ -2382,7 +1849,7 @@ exploded_node::detect_leaks (exploded_graph &eg)
 {
   LOG_FUNC_1 (eg.get_logger (), "EN: %i", m_index);
 
-  gcc_assert (get_point ().get_supernode ()->return_p ());
+  gcc_assert (get_point ().get_supernode ()->exit_p ());
 
   /* If we're not a "top-level" function, do nothing; pop_frame
      will be called when handling the return superedge.  */
@@ -2403,7 +1870,7 @@ exploded_node::detect_leaks (exploded_graph &eg)
   uncertainty_t uncertainty;
   impl_region_model_context ctxt (eg, this,
 				  &old_state, &new_state, &uncertainty, nullptr,
-				  get_stmt ());
+				  nullptr);
   const svalue *result = nullptr;
   new_state.m_region_model->pop_frame (nullptr, &result, &ctxt, nullptr);
   program_state::detect_leaks (old_state, new_state, result,
@@ -2437,56 +1904,92 @@ exploded_node::dump_succs_and_preds (FILE *outf) const
   }
 }
 
-/* class dynamic_call_info_t : public custom_edge_info.  */
+// class interprocedural_call : public custom_edge_info
 
-/* Implementation of custom_edge_info::update_model vfunc
-   for dynamic_call_info_t.
+void
+interprocedural_call::print (pretty_printer *pp) const
+{
+  pp_string (pp, "call to ");
+  pp_gimple_stmt_1 (pp, &m_call_stmt, 0, (dump_flags_t)0);
+}
 
-   Update state for a dynamically discovered call (or return), by pushing
-   or popping the a frame for the appropriate function.  */
+void
+interprocedural_call::get_dot_attrs (const char *&/*out_style*/,
+				     const char *&out_color) const
+{
+  out_color = "red";
+}
 
 bool
-dynamic_call_info_t::update_model (region_model *model,
-				   const exploded_edge *eedge,
-				   region_model_context *ctxt) const
+interprocedural_call::update_state (program_state *state,
+				    const exploded_edge *eedge,
+				    region_model_context *ctxt) const
 {
-  gcc_assert (eedge);
-  if (m_is_returning_call)
-    model->update_for_return_gcall (m_dynamic_call, ctxt);
-  else
-    {
-      function *callee = eedge->m_dest->get_function ();
-      model->update_for_gcall (m_dynamic_call, ctxt, callee);
-    }
+  return update_model (state->m_region_model, eedge, ctxt);
+}
+
+bool
+interprocedural_call::update_model (region_model *model,
+				    const exploded_edge */*eedge*/,
+				    region_model_context *ctxt) const
+{
+  model->update_for_gcall (m_call_stmt, ctxt, &m_callee_fun);
   return true;
 }
 
-/* Implementation of custom_edge_info::add_events_to_path vfunc
-   for dynamic_call_info_t.  */
+void
+interprocedural_call::add_events_to_path (checker_path *emission_path,
+					  const exploded_edge &eedge,
+					  pending_diagnostic &pd) const
+{
+  pd.add_call_event (eedge, m_call_stmt, *emission_path);
+}
+
+// class interprocedural_return : public custom_edge_info
 
 void
-dynamic_call_info_t::add_events_to_path (checker_path *emission_path,
-				   const exploded_edge &eedge) const
+interprocedural_return::print (pretty_printer *pp) const
 {
-  const exploded_node *src_node = eedge.m_src;
-  const program_point &src_point = src_node->get_point ();
-  const int src_stack_depth = src_point.get_stack_depth ();
-  const exploded_node *dest_node = eedge.m_dest;
-  const program_point &dest_point = dest_node->get_point ();
-  const int dest_stack_depth = dest_point.get_stack_depth ();
+  pp_string (pp, "return from ");
+  pp_gimple_stmt_1 (pp, &m_call_stmt, 0, (dump_flags_t)0);
+}
 
-  if (m_is_returning_call)
-    emission_path->add_event
-      (std::make_unique<return_event> (eedge,
-				       event_loc_info (m_dynamic_call.location,
-						       dest_point.get_fndecl (),
-						       dest_stack_depth)));
-  else
-    emission_path->add_event
-      (std::make_unique<call_event> (eedge,
-				     event_loc_info (m_dynamic_call.location,
-						     src_point.get_fndecl (),
-						     src_stack_depth)));
+void
+interprocedural_return::get_dot_attrs (const char *&/*out_style*/,
+				       const char *&out_color) const
+{
+  out_color = "green";
+}
+
+bool
+interprocedural_return::update_state (program_state *state,
+				      const exploded_edge *eedge,
+				      region_model_context *ctxt) const
+{
+  return update_model (state->m_region_model, eedge, ctxt);
+}
+
+bool
+interprocedural_return::update_model (region_model *model,
+				      const exploded_edge */*eedge*/,
+				      region_model_context *ctxt) const
+{
+  model->update_for_return_gcall (m_call_stmt, ctxt);
+  return true;
+}
+
+void
+interprocedural_return::add_events_to_path (checker_path *emission_path,
+					    const exploded_edge &eedge,
+					    pending_diagnostic &) const
+{
+  const program_point &dst_point = eedge.m_dest->get_point ();
+  emission_path->add_event
+    (std::make_unique<return_event>
+       (eedge,
+	event_loc_info (m_call_stmt.location,
+			dst_point.get_fndecl (),
+			dst_point.get_stack_depth ())));
 }
 
 /* class rewind_info_t : public custom_edge_info.  */
@@ -2521,7 +2024,8 @@ rewind_info_t::update_model (region_model *model,
 
 void
 rewind_info_t::add_events_to_path (checker_path *emission_path,
-				   const exploded_edge &eedge) const
+				   const exploded_edge &eedge,
+				   pending_diagnostic &) const
 {
   const exploded_node *src_node = eedge.m_src;
   const program_point &src_point = src_node->get_point ();
@@ -2585,34 +2089,20 @@ exploded_edge::dump_dot_label (pretty_printer *pp) const
   const char *constraint = "true";
 
   if (m_sedge)
-    switch (m_sedge->m_kind)
-      {
-      default:
-	gcc_unreachable ();
-      case SUPEREDGE_CFG_EDGE:
-	break;
-      case SUPEREDGE_CALL:
-	color = "red";
-	//constraint = "false";
-	break;
-      case SUPEREDGE_RETURN:
-	color = "green";
-	//constraint = "false";
-	break;
-      case SUPEREDGE_INTRAPROCEDURAL_CALL:
-	style = "\"dotted\"";
-	break;
-      }
-  if (m_custom_info)
     {
-      color = "red";
-      style = "\"dotted\"";
+      if (m_sedge->get_op ())
+	style = "\"solid\"";
+      else
+	style = "\"dotted\"";
     }
+  if (m_custom_info)
+    m_custom_info->get_dot_attrs (style, color);
 
   pp_printf (pp,
 	     (" [style=%s, color=%s, weight=%d, constraint=%s,"
 	      " headlabel=\""),
 	     style, color, weight, constraint);
+  pp_flush (pp);
 
   if (m_sedge)
     m_sedge->dump_label_to_pp (pp, false);
@@ -2622,7 +2112,7 @@ exploded_edge::dump_dot_label (pretty_printer *pp) const
   pp_printf (pp, "%s",
 	     could_do_work_p () ? "(could do work)" : "DOES NO WORK");
 
-  //pp_write_text_as_dot_label_to_stream (pp, /*for_record=*/false);
+  pp_write_text_as_dot_label_to_stream (pp, /*for_record=*/false);
 
   pp_printf (pp, "\"];\n");
 }
@@ -2651,17 +2141,33 @@ exploded_edge::to_json () const
   return eedge_obj;
 }
 
+const gimple *
+exploded_edge::maybe_get_stmt () const
+{
+  auto op = maybe_get_op ();
+  if (!op)
+    return nullptr;
+  return op->maybe_get_stmt ();
+}
+
+const operation *
+exploded_edge::maybe_get_op () const
+{
+  if (!m_sedge)
+    return nullptr;
+  return m_sedge->get_op ();
+}
+
 /* struct stats.  */
 
 /* stats' ctor.  */
 
 stats::stats (int num_supernodes)
-: m_node_reuse_count (0),
+: m_num_nodes (0),
+  m_node_reuse_count (0),
   m_node_reuse_after_merge_count (0),
   m_num_supernodes (num_supernodes)
 {
-  for (int i = 0; i < NUM_POINT_KINDS; i++)
-    m_num_nodes[i] = 0;
 }
 
 /* Log these stats in multiline form to LOGGER.  */
@@ -2670,11 +2176,7 @@ void
 stats::log (logger *logger) const
 {
   gcc_assert (logger);
-  for (int i = 0; i < NUM_POINT_KINDS; i++)
-    if (m_num_nodes[i] > 0)
-      logger->log ("m_num_nodes[%s]: %i",
-		   point_kind_to_string (static_cast <enum point_kind> (i)),
-		   m_num_nodes[i]);
+  logger->log ("m_num_nodes: %i", m_num_nodes);
   logger->log ("m_node_reuse_count: %i", m_node_reuse_count);
   logger->log ("m_node_reuse_after_merge_count: %i",
 	       m_node_reuse_after_merge_count);
@@ -2685,18 +2187,14 @@ stats::log (logger *logger) const
 void
 stats::dump (FILE *out) const
 {
-  for (int i = 0; i < NUM_POINT_KINDS; i++)
-    if (m_num_nodes[i] > 0)
-      fprintf (out, "m_num_nodes[%s]: %i\n",
-	       point_kind_to_string (static_cast <enum point_kind> (i)),
-	       m_num_nodes[i]);
+  fprintf (out, "m_num_nodes: %i\n", m_num_nodes);
   fprintf (out, "m_node_reuse_count: %i\n", m_node_reuse_count);
   fprintf (out, "m_node_reuse_after_merge_count: %i\n",
 	   m_node_reuse_after_merge_count);
 
   if (m_num_supernodes > 0)
-    fprintf (out, "PK_AFTER_SUPERNODE nodes per supernode: %.2f\n",
-	     (float)m_num_nodes[PK_AFTER_SUPERNODE] / (float)m_num_supernodes);
+    fprintf (out, "enodes per supernode: %.2f\n",
+	     (float)m_num_nodes / (float)m_num_supernodes);
 }
 
 /* Return the total number of enodes recorded within this object.  */
@@ -2704,10 +2202,7 @@ stats::dump (FILE *out) const
 int
 stats::get_total_enodes () const
 {
-  int result = 0;
-  for (int i = 0; i < NUM_POINT_KINDS; i++)
-    result += m_num_nodes[i];
-  return result;
+  return m_num_nodes;
 }
 
 /* struct per_function_data.  */
@@ -2728,17 +2223,17 @@ per_function_data::add_call_summary (exploded_node *node)
 
 strongly_connected_components::
 strongly_connected_components (const supergraph &sg, logger *logger)
-: m_sg (sg), m_per_node (m_sg.num_nodes ())
+: m_sg (sg), m_per_node (m_sg.m_nodes.length ())
 {
   LOG_SCOPE (logger);
   auto_timevar tv (TV_ANALYZER_SCC);
 
-  for (int i = 0; i < m_sg.num_nodes (); i++)
+  for (int i = 0; i < m_sg.m_nodes.length (); i++)
     m_per_node.quick_push (per_node_data ());
 
-  for (int i = 0; i < m_sg.num_nodes (); i++)
-    if (m_per_node[i].m_index == -1)
-      strong_connect (i);
+  for (auto snode : m_sg.m_nodes)
+    if (m_per_node[snode->m_id].m_id == -1)
+      strong_connect (snode->m_id, logger);
 
   if (0)
     dump ();
@@ -2749,11 +2244,22 @@ strongly_connected_components (const supergraph &sg, logger *logger)
 DEBUG_FUNCTION void
 strongly_connected_components::dump () const
 {
-  for (int i = 0; i < m_sg.num_nodes (); i++)
+  fprintf (stderr, "Stack: [");
+  bool first = true;
+  for (auto i : m_stack)
+    {
+      if (first)
+	first = false;
+      else
+	fprintf (stderr, ", ");
+      fprintf (stderr, "%i", i);
+    }
+  fprintf (stderr, "]\n");
+  for (int i = 0; i < m_sg.m_nodes.length (); i++)
     {
       const per_node_data &v = m_per_node[i];
       fprintf (stderr, "SN %i: index: %i lowlink: %i on_stack: %i\n",
-	       i, v.m_index, v.m_lowlink, v.m_on_stack);
+	       i, v.m_id, v.m_lowlink, v.m_on_stack);
     }
 }
 
@@ -2763,7 +2269,7 @@ std::unique_ptr<json::array>
 strongly_connected_components::to_json () const
 {
   auto scc_arr = std::make_unique<json::array> ();
-  for (int i = 0; i < m_sg.num_nodes (); i++)
+  for (int i = 0; i < m_sg.m_nodes.length (); i++)
     scc_arr->append (std::make_unique<json::integer_number> (get_scc_id (i)));
   return scc_arr;
 }
